#
# Simplest possible AJAX-twisted.web2-SAGE script 
#
# USAGE: 
#       $ sage simple_ajax_twisted_sage.py
#
# --- Only tested in Firefox on Linux. Your mileage may vary. ---
# 
# Alex Clemesha <clemesha@gmail.com> 2007
#
from twisted.web2 import resource
from twisted.web2 import http_headers
from twisted.web2 import http
from twisted.web2 import channel
from twisted.web2 import server

from sage.interfaces import sage0

HTML = """
<html>
<head>
<script type="text/javascript">

var axajObject = createRequestObject();

function createRequestObject() {  
    var xmlhttp;
    try { xmlhttp=new ActiveXObject("Msxml2.XMLHTTP"); }
  catch(e) {
    try {
        xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(e) {
        xmlhttp=null;
    }
  }
  if(!xmlhttp&&typeof XMLHttpRequest!="undefined") {
    xmlhttp=new XMLHttpRequest();
  }
    return  xmlhttp;
}

function sendRequest(event) {
    var code = document.getElementById("code").value;
    if (code.length > 0 && event.keyCode == 13) {
        var ecode = encodeURIComponent(code);
        var req = "/eval?code=" + ecode;
        try{
            axajObject.open("POST", req, true);
            axajObject.setRequestHeader('Content-Type',  "text/html");
            axajObject.onreadystatechange = handleResponse;
            axajObject.send("");
        }
        catch(e){
            // caught an error
            alert('Request send failed.');
        }
        finally{}
    }
}

function handleResponse() {
    if(axajObject.readyState == 4){
        var response = axajObject.responseText;
        var code = document.getElementById("code").value;
        var res = "<p>Result of " + code + ":&nbsp;&nbsp;" + response + "</p>";
        document.getElementById("output").innerHTML = res; 
    }
}
</script>

<style type="text/css">
    #container{text-align:center;width:550px;border:1px solid #387CAF}
    #output{text-align:center;font-size:14px;font-weight:bold}
</style>

</head>
    
<body>
    <div id="container">
        <h3>Simplest possible AJAX SAGE calculator.</h3> 
        <p>Type in some valid SAGE code a hit enter</p><br/><br/>
        Code:&nbsp;<input type="text" id="code" name="code" onkeypress="sendRequest(event)"></label>&nbsp;
        <br/><br/>
        <span id="output"></span>
        <br/><br/><br/><br/>
    </div>
</body>
</html>
"""

class Root(resource.Resource):
    addSlash = True

    def __init__(self):
        self.child_eval = EvalSomeSAGECode()

    def render(self, request):
        return http.Response(200, {'content-type': http_headers.MimeType('text', 'html')}, HTML)

class EvalSomeSAGECode(resource.PostableResource):

    def render(self, request):
        code = request.args.get('code')[0]
        print code
        result = sage0.sage0.eval(code)
        print result
        return http.Response(200, {'content-type': http_headers.MimeType('text', 'html')}, result)

if __name__ == "__main__":
    from twisted.internet import reactor
    site = server.Site(Root())
    factory = channel.HTTPFactory(site)
    reactor.listenTCP(8000, factory)
    print "\nOpen your browser to 'http://localhost:8000'\n"
    reactor.run()





