def cyclic6_affine(compute=True):
    x,y,z,t,u,v = PolynomialRing(QQ, ZZ(6), names='xyztuv', ord='lex').gens()
    I = ideal(
        x + y + z + t + u + v,
        x*y + y*z + z*t + t*u + u*v + v*x,
        x*y*z + y*z*t + z*t*u + t*u*v + u*v*x + v*x*y,
        x*y*z*t + y*z*t*u + z*t*u*v + t*u*v*x + u*v*x*y + v*x*y*z,
        x*y*z*t*u + y*z*t*u*v + z*t*u*v*x + t*u*v*x*y + u*v*x*y*z + v*x*y*z*t,
        x*y*z*t*u*v - ZZ(1))
    if not compute:
        return I
    t = cputime()
    B = I.groebner_basis()
    print 'finished gb for cyclic 6 in %s seconds'%cputime(t)

def cyclic6_homog(compute=True):
    x,y,z,t,u,v,w = PolynomialRing(QQ, ZZ(7), names='xyztuvw').gens()
    I = ideal(
        x + y + z + t + u + v,
        x*y + y*z + z*t + t*u + u*v + v*x,
        x*y*z + y*z*t + z*t*u + t*u*v + u*v*x + v*x*y,
        x*y*z*t + y*z*t*u + z*t*u*v + t*u*v*x + u*v*x*y + v*x*y*z,
        x*y*z*t*u + y*z*t*u*v + z*t*u*v*x + t*u*v*x*y + u*v*x*y*z + v*x*y*z*t,
        x*y*z*t*u*v - w**ZZ(5))
    if not compute:
        return I
    t = cputime()
    B = I.groebner_basis()
    print 'finished gb for cyclic 6 in %s seconds'%cputime(t)

