include "gsl.pxi"
import sys
def main():
  cdef double a, b
  cdef size_t n

  if (len(sys.argv) != 4):
    print '''Usage: gsl-histogram xmin xmax 
#Computes a histogram of the data on stdin using n bins from xmin to xmax\n'''
#    sys.exit (0)

  a = float(sys.argv[1])
  b = float(sys.argv[2])
  n = float(sys.argv[3])
  cdef double x

  cdef gsl_histogram * h 
  h = gsl_histogram_alloc (n)
            
  gsl_histogram_set_ranges_uniform (h, a, b)
  
  fh = file('histogram.dat')
  ah = map(float,fh.read().split())

  for x in ah:
    gsl_histogram_increment (h, x)

  gsl_histogram_fprintf (stdout, h, "%g", "%g")

  gsl_histogram_free (h)
  
