include "gsl.pxi"
import sys
def main():
  
  cdef gsl_rng_type * T
  cdef gsl_rng * r

  cdef gsl_histogram2d * h 
  h = gsl_histogram2d_alloc (10, 10)

  gsl_histogram2d_set_ranges_uniform (h, 0.0, 1.0, 0.0, 1.0)

  gsl_histogram2d_accumulate (h, 0.3, 0.3, 1)
  gsl_histogram2d_accumulate (h, 0.8, 0.1, 5)
  gsl_histogram2d_accumulate (h, 0.7, 0.9, 0.5)

  gsl_rng_env_setup ()
  
  T = gsl_rng_default
  r = gsl_rng_alloc (T)

  cdef int i
  cdef gsl_histogram2d_pdf * p 
  p  = gsl_histogram2d_pdf_alloc (h.nx, h.ny)
    
  gsl_histogram2d_pdf_init (p, h)

  cdef double x, y, u, v
  for i  from 0 <= i < 1000:
    u = gsl_rng_uniform (r)
    v = gsl_rng_uniform (r)
       
    gsl_histogram2d_pdf_sample (p, u, v, &x, &y)
      
    print "%g %g\n" % (x, y)
  
