
cdef struct quadratic_params:
    double a, b, c


cdef double quadratic (double x, void *params):
  cdef quadratic_params *p 
  cdef double a,b,c
  p  = <quadratic_params *> params

  a = p.a
  b = p.b
  c = p.c

  return (a * x + b) * x + c

cdef double quadratic_deriv (double x, void *params):
  cdef quadratic_params *p 
  cdef double a,b,c
  p = <quadratic_params *> params
  
  a = p.a
  b = p.b
  c = p.c

  return 2.0 * a * x + b

cdef void quadratic_fdf (double x, void *params, double *y, double *dy):
  cdef quadratic_params *p 
  cdef double a,b,c
  p  = < quadratic_params *> params

  a = p.a
  b = p.b
  c = p.c

  y[0] = (a * x + b) * x + c
  dy[0] = 2.0 * a * x + b

