include "gsl.pxi"
include "demo.pxi"

def main ():
  cdef int status, iter, max_iter
  iter = 0
  max_iter = 100
  cdef gsl_root_fsolver_type *T
  cdef gsl_root_fsolver *s
  cdef double r, r_expected, x_lo, x_hi
  r = 0
  r_expected = sqrt (5.0)
  x_lo = 0.0
  x_hi = 5.0
  cdef gsl_function F
  cdef quadratic_params params 
  params.a = 1.0
  params.b = 0.0
  params.c = -5.0
  F.function = &quadratic
  F.params = &params

  T = gsl_root_fsolver_brent
  s = gsl_root_fsolver_alloc (T)
  gsl_root_fsolver_set (s, &F, x_lo, x_hi)

  print "using %s method\n" % gsl_root_fsolver_name (s)

  print "%5s [%9s, %9s] %9s %10s %9s\n" % \
          ("iter", "lower", "upper", "root", "err", "err(est)"),

  cdef double GSL_CONTINUE 
  GSL_CONTINUE = -2  # to go...
  iter = iter + 1
  status = gsl_root_fsolver_iterate (s)
  r = gsl_root_fsolver_root (s)
  x_lo = gsl_root_fsolver_x_lower (s)
  x_hi = gsl_root_fsolver_x_upper (s)
  status = gsl_root_test_interval (x_lo, x_hi, 0, 0.001)
  if (status == GSL_SUCCESS):
    print "Converged:\n"
  print "%5d [%.7f, %.7f] %.7f %+.7f %.7f\n" % \
    (iter, x_lo, x_hi, r, r - r_expected, x_hi - x_lo),

  while (status == GSL_CONTINUE and iter < max_iter):
      iter = iter + 1
      status = gsl_root_fsolver_iterate (s)
      r = gsl_root_fsolver_root (s)
      x_lo = gsl_root_fsolver_x_lower (s)
      x_hi = gsl_root_fsolver_x_upper (s)
      status = gsl_root_test_interval (x_lo, x_hi, 0, 0.001)

      if (status == GSL_SUCCESS):
        print "Converged:\n"

      print "%5d [%.7f, %.7f] %.7f %+.7f %.7f\n" % \
              (iter, x_lo, x_hi, r, r - r_expected, x_hi - x_lo)
