def ds(m, h):
    """
    Permanent of the m x (m+h) matrix, etc.

    INPUT:
        m -- integer
        h -- integer



    EXAMPLES:
        sage.: load "perm.sage"
        sage: ds(5,3)
        212

    AUTHOR:
        -- Jaap Spies (2006)
    """
    n = m + h
    M = MatrixSpace(QQ, m, n)
    A = M([0 for i in range(m*n)])
    for i in range(m):
        for j in range(n):
            if i <= j and j <= i + h:
                A[i,j] = 1
    return A.permanent()
